#if defined(F2806)
  #define FLASH_F2808   0
  #define FLASH_F2806   1
  #define FLASH_F2802   0
  #define FLASH_F2801   0
#elif defined(F2808)
  #define FLASH_F2808   1
  #define FLASH_F2806   0
  #define FLASH_F2802   0
  #define FLASH_F2801   0
#elif defined(F2802)
  #define FLASH_F2808   0
  #define FLASH_F2806   0
  #define FLASH_F2802   1
  #define FLASH_F2801   0
#elif defined(F2801) 
  #define FLASH_F2808   0
  #define FLASH_F2806   0
  #define FLASH_F2802   0
  #define FLASH_F2801   1
#else
  #error F280x macro not defined
#endif

#define SECTORA   (uint16)0x0001
#define SECTORB   (uint16)0x0002
#define SECTORC   (uint16)0x0004
#define SECTORD   (uint16)0x0008
typedef struct {
     uint32 StartAddr;
     uint32 EndAddr;
} SECTOR; 
#if FLASH_F2808
SECTOR Sector[4] = {
         0x3F4000,0x3F7FFF,
         0x3F0000,0x3F3FFF,
         0x3EC000,0x3EFFFF,
         0x3E8000,0x3EBFFF
};

#endif

#if FLASH_F2806
SECTOR Sector[4] = {
         0x3F6000,0x3F7FFF,
         0x3F4000,0x3F5FFF,
         0x3F2000,0x3F3FFF,
         0x3F0000,0x3F1FFF
};
#endif

#if FLASH_F2802
SECTOR Sector[4] = {
         0x3F6000,0x3F7FFF,
         0x3F4000,0x3F5FFF,
         0x3F2000,0x3F3FFF,
         0x3F0000,0x3F1FFF
};
#endif

#if FLASH_F2801
SECTOR Sector[4] = {
         0x3F7000,0x3F7FFF,
         0x3F6000,0x3F5FFF,
         0x3F5000,0x3F5FFF,
         0x3F4000,0x3F4FFF
};
#endif

typedef struct {
    uint32  FirstFailAddr;
    uint16  ExpectedData;
    uint16  ActualData;
}FLASH_ST;

#if FLASH_F2801
#define Flash_Erase(a,b)          Flash2801_Erase(a,b)
#define Flash_Program(a,b,c,d)    Flash2801_Program(a,b,c,d)
#define Flash_Verify(a,b,c,d)     Flash2801_Verify(a,b,c,d)
#define Flash_DepRecover()        Flash2801_DepRecover()

#elif FLASH_F2802
#define Flash_Erase(a,b)          Flash2802_Erase(a,b)
#define Flash_Program(a,b,c,d)    Flash2802_Program(a,b,c,d)
#define Flash_Verify(a,b,c,d)     Flash2802_Verify(a,b,c,d)
#define Flash_DepRecover()        Flash2802_DepRecover()   

#elif FLASH_F2806
#define Flash_Erase(a,b)          Flash2806_Erase(a,b)
#define Flash_Program(a,b,c,d)    Flash2806_Program(a,b,c,d)
#define Flash_Verify(a,b,c,d)     Flash2806_Verify(a,b,c,d)
#define Flash_DepRecover()        Flash2806_DepRecover()   

#elif FLASH_F2808
#define Flash_Erase(a,b)          Flash2808_Erase(a,b)
#define Flash_Program(a,b,c,d)    Flash2808_Program(a,b,c,d)
#define Flash_Verify(a,b,c,d)     Flash2808_Verify(a,b,c,d)
#define Flash_DepRecover()        Flash2808_DepRecover()
#endif

extern uint16  Flash_Erase(uint16 SectorMask, FLASH_ST *FEraseStat);
extern uint16  Flash_Program(uint16 *FlashAddr, uint16 *BufAddr, uint32 Length, FLASH_ST *FProgStatus);
extern uint16  Flash_Verify(uint16 *StartAddr, uint16 *BufAddr, uint32 Length, FLASH_ST *FVerifyStat);
extern uint16  Flash_DepRecover();

/*---------------------------------------------------------------------------
   Frequency Scale factor:
   The calling program must provide this global parameter used
   for frequency scaling the algo's.
----------------------------------------------------------------------------*/

extern uint32 Flash_CPUScaleFactor;

// --------- END OF FILE ----------------------------------

